diff -urNEBb binutils-2.14-orig/gas/config/te-amithlon.h binutils-2.14/gas/config/te-amithlon.h
--- binutils-2.14-orig/gas/config/te-amithlon.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/gas/config/te-amithlon.h	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,26 @@
+/* te-amithlon.h -- Amithlon target environment declarations.
+   Copyright 2000 Free Software Foundation, Inc.
+
+   This file is part of GAS, the GNU Assembler.
+
+   GAS is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   GAS is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with GAS; see the file COPYING.  If not, write to the Free
+   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
+   02111-1307, USA.  */
+
+#define TE_Amithlon 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#include "obj-format.h"
diff -urNEBb binutils-2.14-orig/gas/config/te-morphos.h binutils-2.14/gas/config/te-morphos.h
--- binutils-2.14-orig/gas/config/te-morphos.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/gas/config/te-morphos.h	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,14 @@
+/*
+ * te-amiga.h -- Amiga target environment declarations.
+ */
+
+#define TE_MORPHOS 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#ifdef OBJ_HEADER
+#include OBJ_HEADER
+#else
+#include "obj-format.h"
+#endif
diff -urNEBb binutils-2.14-orig/gas/configure.in binutils-2.14/gas/configure.in
--- binutils-2.14-orig/gas/configure.in	2003-06-02 21:35:22.000000000 +0200
+++ binutils-2.14/gas/configure.in	2003-12-02 14:09:40.000000000 +0100
@@ -119,7 +119,8 @@
       arm*|xscale*|strongarm*)    cpu_type=arm endian=little ;;
       hppa*)		cpu_type=hppa ;;
 changequote(,)dnl
-      i[3456]86)	cpu_type=i386 arch=i386;;
+      i[3456]86)	cpu_type=i386 arch=i386 endian=little;;
+      i[3456]86be)	cpu_type=i386 arch=i386 endian=big;;
       x86_64)		cpu_type=i386 arch=x86_64;;
       ia64)		cpu_type=ia64 ;;
       ip2k)             cpu_type=ip2k endian=big ;; 
@@ -263,6 +264,7 @@
       i386-*-linux*coff*)		fmt=coff em=linux ;;
       i386-*-linux-gnu*)		fmt=elf em=linux ;;
       x86_64-*-linux-gnu*)		fmt=elf em=linux ;;
+      i386-*-amithlon*)	    		fmt=elf em=amithlon ;;
       i386-*-lynxos*)			fmt=coff em=lynx ;;
 changequote(,)dnl
       i386-*-sysv[45]*)			fmt=elf ;;
@@ -326,6 +328,8 @@
       m68hc11-*-* | m6811-*-*)		fmt=elf ;;
       m68hc12-*-* | m6812-*-*)		fmt=elf ;;
 
+      m68*-*-amigaoshunk)   		fmt=amigahunk em=amiga bfd_gas=yes ;;
+      m68*-*-amigaos*)      		fmt=aout em=amiga ;;
       m68k-*-vxworks*)			fmt=aout em=sun3 ;;
       m68k-ericsson-ose)		fmt=aout em=sun3 ;;
       m68k-*-sunos*)			fmt=aout em=sun3 ;;
@@ -387,6 +391,8 @@
       or32-*-elf)			fmt=elf ;;
       pj*)				fmt=elf ;;
 
+      ppc-*-amiga*)         		fmt=elf em=amigaos ;;
+      ppc-*-morphos*)			fmt=elf em=morphos ;;
       ppc-*-pe | ppc-*-cygwin*)		fmt=coff em=pe ;;
       ppc-*-winnt*)			fmt=coff em=pe ;;
       ppc-*-aix5*)			fmt=coff em=aix5 ;;
@@ -895,7 +901,7 @@
 
 case ${primary_bfd_gas}-${target_cpu_type}-${obj_format} in
   yes-*-coff)	need_bfd=yes ;;
-  no-*-coff)	need_bfd=yes
+  no-*-coff | yes-m68k-amigahunk | no-m68k-amigahunk)	need_bfd=yes
 		AC_DEFINE(MANY_SEGMENTS, 1, [old COFF support?]) ;;
 esac
 
@@ -948,6 +954,17 @@
 
 AC_PROG_CC
 
+### begin-GG-local
+# Check for additional host specific CFLAGS.
+AC_MSG_CHECKING(for host dependent CFLAGS)
+other_host_cflags=""
+case "${host}" in
+	m68*-*-amigaos*)	other_host_cflags="-mstackextend" ;;
+esac
+test -n "$other_host_cflags" && CFLAGS="$CFLAGS $other_host_cflags"
+AC_MSG_RESULT($other_host_cflags)
+### end-GG-local
+
 AC_PROG_YACC
 AM_PROG_LEX
 
diff -urNEBb binutils-2.14-orig/gas/doc/Makefile.am binutils-2.14/gas/doc/Makefile.am
--- binutils-2.14-orig/gas/doc/Makefile.am	2003-04-01 16:50:30.000000000 +0200
+++ binutils-2.14/gas/doc/Makefile.am	2003-12-02 14:09:40.000000000 +0100
@@ -67,7 +67,7 @@
 
 # We want install to imply install-info as per GNU standards, despite the
 # cygnus option.
-install: install-info
+#install: install-info
 
 # This one isn't ready for prime time yet.  Not even a little bit.
 
diff -urNEBb binutils-2.14-orig/gas/read.h binutils-2.14/gas/read.h
--- binutils-2.14-orig/gas/read.h	2003-01-11 07:24:12.000000000 +0100
+++ binutils-2.14/gas/read.h	2003-12-02 14:09:40.000000000 +0100
@@ -144,6 +144,9 @@
 extern void s_bad_endr PARAMS ((int));
 extern void s_comm PARAMS ((int));
 extern void s_data PARAMS ((int));
+#ifdef OBJ_AMIGAHUNK
+extern void s_data_chip PARAMS ((int));
+#endif
 extern void s_desc PARAMS ((int));
 extern void s_else PARAMS ((int arg));
 extern void s_elseif PARAMS ((int arg));
diff -urNEBb binutils-2.14-orig/gas/write.c binutils-2.14/gas/write.c
--- binutils-2.14-orig/gas/write.c	2003-04-07 04:54:00.000000000 +0200
+++ binutils-2.14/gas/write.c	2003-12-02 14:09:40.000000000 +0100
@@ -160,7 +160,7 @@
 static fixS *fix_new_internal PARAMS ((fragS *, int where, int size,
 				       symbolS *add, symbolS *sub,
 				       offsetT offset, int pcrel,
-				       RELOC_ENUM r_type));
+				       RELOC_ENUM r_type, int baserel));
 #if defined (BFD_ASSEMBLER) || (!defined (BFD) && !defined (OBJ_VMS))
 static long fixup_segment PARAMS ((fixS *, segT));
 #endif
@@ -190,7 +190,7 @@
 
 static fixS *
 fix_new_internal (frag, where, size, add_symbol, sub_symbol, offset, pcrel,
-		  r_type)
+		  r_type, baserel)
      fragS *frag;		/* Which frag?  */
      int where;			/* Where in that frag?  */
      int size;			/* 1, 2, or 4 usually.  */
@@ -199,6 +199,7 @@
      offsetT offset;		/* X_add_number.  */
      int pcrel;			/* TRUE if PC-relative relocation.  */
      RELOC_ENUM r_type ATTRIBUTE_UNUSED; /* Relocation type.  */
+     int baserel;               /* TRUE if base-relative data */
 {
   fixS *fixP;
 
@@ -239,6 +240,7 @@
 #endif
 
 #ifdef TC_FIX_TYPE
+  fixP->tc_fix_data = baserel;
   TC_INIT_FIX_DATA (fixP);
 #endif
 
@@ -283,7 +285,7 @@
 /* Create a fixup relative to a symbol (plus a constant).  */
 
 fixS *
-fix_new (frag, where, size, add_symbol, offset, pcrel, r_type)
+fix_new (frag, where, size, add_symbol, offset, pcrel, r_type, baserel)
      fragS *frag;		/* Which frag?  */
      int where;			/* Where in that frag?  */
      int size;			/* 1, 2, or 4 usually.  */
@@ -291,9 +293,10 @@
      offsetT offset;		/* X_add_number.  */
      int pcrel;			/* TRUE if PC-relative relocation.  */
      RELOC_ENUM r_type;		/* Relocation type.  */
+     int baserel;               /* TRUE if base-relative data */
 {
   return fix_new_internal (frag, where, size, add_symbol,
-			   (symbolS *) NULL, offset, pcrel, r_type);
+			   (symbolS *) NULL, offset, pcrel, r_type, baserel);
 }
 
 /* Create a fixup for an expression.  Currently we only support fixups
@@ -301,13 +304,14 @@
    file formats support anyhow.  */
 
 fixS *
-fix_new_exp (frag, where, size, exp, pcrel, r_type)
+fix_new_exp (frag, where, size, exp, pcrel, r_type, baserel)
      fragS *frag;		/* Which frag?  */
      int where;			/* Where in that frag?  */
      int size;			/* 1, 2, or 4 usually.  */
      expressionS *exp;		/* Expression.  */
      int pcrel;			/* TRUE if PC-relative relocation.  */
      RELOC_ENUM r_type;		/* Relocation type.  */
+     int baserel;               /* TRUE if base-relative data */
 {
   symbolS *add = NULL;
   symbolS *sub = NULL;
@@ -333,7 +337,7 @@
 	exp->X_add_symbol = stmp;
 	exp->X_add_number = 0;
 
-	return fix_new_exp (frag, where, size, exp, pcrel, r_type);
+	return fix_new_exp (frag, where, size, exp, pcrel, r_type, baserel);
       }
 
     case O_symbol_rva:
@@ -371,7 +375,7 @@
       break;
     }
 
-  return fix_new_internal (frag, where, size, add, sub, off, pcrel, r_type);
+  return fix_new_internal (frag, where, size, add, sub, off, pcrel, r_type, baserel);
 }
 
 /* Generic function to determine whether a fixup requires a relocation.  */
@@ -1666,17 +1670,17 @@
 #ifdef TC_CONS_FIX_NEW
 	  TC_CONS_FIX_NEW (lie->frag,
 			   lie->word_goes_here - lie->frag->fr_literal,
-			   2, &exp);
+			   2, &exp, 0);
 #else
 	  fix_new_exp (lie->frag,
 		       lie->word_goes_here - lie->frag->fr_literal,
-		       2, &exp, 0, BFD_RELOC_16);
+		       2, &exp, 0, BFD_RELOC_16, 0);
 #endif
 #else
 #if defined(TC_SPARC) || defined(TC_A29K) || defined(NEED_FX_R_TYPE)
 	  fix_new_exp (lie->frag,
 		       lie->word_goes_here - lie->frag->fr_literal,
-		       2, &exp, 0, NO_RELOC);
+		       2, &exp, 0, NO_RELOC, 0);
 #else
 #ifdef TC_NS32K
 	  fix_new_ns32k_exp (lie->frag,
@@ -1685,7 +1689,7 @@
 #else
 	  fix_new_exp (lie->frag,
 		       lie->word_goes_here - lie->frag->fr_literal,
-		       2, &exp, 0, 0);
+		       2, &exp, 0, 0, 0);
 #endif /* TC_NS32K  */
 #endif /* TC_SPARC|TC_A29K|NEED_FX_R_TYPE  */
 #endif /* BFD_ASSEMBLER  */
@@ -2564,6 +2568,11 @@
 {
   long seg_reloc_count = 0;
   valueT add_number;
+  int size;
+  char *place;
+  long where;
+  int pcrel, plt;
+  char baserel = 0;
   fragS *fragP;
   segT add_symbol_segment = absolute_section;
 
@@ -2617,6 +2626,11 @@
       TC_VALIDATE_FIX (fixP, this_segment, skip);
 #endif
       add_number = fixP->fx_offset;
+      pcrel = fixP->fx_pcrel;
+      plt = fixP->fx_plt;
+#ifdef TC_FIX_TYPE
+      baserel = fixP->tc_fix_data;
+#endif
 
       if (fixP->fx_addsy != NULL
 	  && symbol_mri_common_p (fixP->fx_addsy))
@@ -2753,6 +2767,11 @@
 	    symbol_mark_used_in_reloc (fixP->fx_subsy);
 	}
 
+#if !defined(BFD_ASSEMBLER) && !defined(MANY_SEGMENTS)
+      if (baserel && add_number)
+        add_number -= text_last_frag->fr_address;
+#endif
+
       if (!fixP->fx_bit_fixP && !fixP->fx_no_overflow && fixP->fx_size != 0)
 	{
 	  if (fixP->fx_size < sizeof (valueT))
diff -urNEBb binutils-2.14-orig/gas/write.h binutils-2.14/gas/write.h
--- binutils-2.14-orig/gas/write.h	2002-09-20 00:51:34.000000000 +0200
+++ binutils-2.14/gas/write.h	2003-12-02 14:09:40.000000000 +0100
@@ -198,17 +198,18 @@
 #ifdef BFD_ASSEMBLER
 extern fixS *fix_new
   PARAMS ((fragS * frag, int where, int size, symbolS * add_symbol,
-	   offsetT offset, int pcrel, bfd_reloc_code_real_type r_type));
+	   offsetT offset, int pcrel, bfd_reloc_code_real_type r_type,
+	   int baserel));
 extern fixS *fix_new_exp
   PARAMS ((fragS * frag, int where, int size, expressionS *exp, int pcrel,
-	   bfd_reloc_code_real_type r_type));
+	   bfd_reloc_code_real_type r_type, int baserel));
 #else
 extern fixS *fix_new
   PARAMS ((fragS * frag, int where, int size, symbolS * add_symbol,
-	   offsetT offset, int pcrel, int r_type));
+	   offsetT offset, int pcrel, int r_type, int baserel));
 extern fixS *fix_new_exp
   PARAMS ((fragS * frag, int where, int size, expressionS *exp, int pcrel,
-	   int r_type));
+	   int r_type, int baserel));
 #endif
 
 extern void write_print_statistics PARAMS ((FILE *));
diff -urNEBb binutils-2.14-orig/gprof/Makefile.am binutils-2.14/gprof/Makefile.am
--- binutils-2.14-orig/gprof/Makefile.am	2002-04-04 15:07:22.000000000 +0200
+++ binutils-2.14/gprof/Makefile.am	2003-12-02 14:09:40.000000000 +0100
@@ -36,7 +36,7 @@
 BUILT_SOURCES = flat_bl.c bsd_callg_bl.c fsf_callg_bl.c
 EXTRA_DIST    = $(BUILT_SOURCES) bbconv.pl $(man_MANS)
 
-diststuff: $(BUILT_SOURCES) info $(man_MANS)
+diststuff: $(BUILT_SOURCES) info guide $(man_MANS)
 
 .m.c:
 	awk -f $(srcdir)/gen-c-prog.awk > ./$*.c \
@@ -73,7 +73,7 @@
 
 # We want install to imply install-info as per GNU standards, despite the
 # cygnus option.
-install: install-info
+#install: install-info
 
 # Targets to rebuild dependencies in this Makefile.
 # Have to get rid of DEP1 here so that "$?" later includes all sources.
diff -urNEBb binutils-2.14-orig/gprof/configure.in binutils-2.14/gprof/configure.in
--- binutils-2.14-orig/gprof/configure.in	2002-12-02 15:02:54.000000000 +0100
+++ binutils-2.14/gprof/configure.in	2003-12-02 14:09:40.000000000 +0100
@@ -26,6 +26,17 @@
 ALL_LINGUAS="fr tr sv es id da pt_BR"
 CY_GNU_GETTEXT
 
+### begin-GG-local
+# Check for additional host specific CFLAGS.
+AC_MSG_CHECKING(for host dependent CFLAGS)
+other_host_cflags=""
+case "${host}" in
+	m68*-*-amigaos*)	other_host_cflags="-mstackextend" ;;
+esac
+test -n "$other_host_cflags" && CFLAGS="$CFLAGS $other_host_cflags"
+AC_MSG_RESULT($other_host_cflags)
+### end-GG-local
+
 AM_MAINTAINER_MODE
 AC_EXEEXT
 
diff -urNEBb binutils-2.14-orig/gprof/gprof.c binutils-2.14/gprof/gprof.c
--- binutils-2.14-orig/gprof/gprof.c	2002-11-30 09:39:44.000000000 +0100
+++ binutils-2.14/gprof/gprof.c	2004-05-07 14:25:40.000000000 +0200
@@ -87,7 +87,9 @@
 {
   "_gprof_mcount", "mcount", "_mcount", "__mcount", "__mcount_internal",
   "__mcleanup",
+#ifndef __amigaos4__
   "<locore>", "<hicore>",
+#endif  
   0
 };
 
diff -urNEBb binutils-2.14-orig/gprof/hist.c binutils-2.14/gprof/hist.c
--- binutils-2.14-orig/gprof/hist.c	2002-11-30 09:39:44.000000000 +0100
+++ binutils-2.14/gprof/hist.c	2004-05-07 14:20:47.000000000 +0200
@@ -313,6 +313,14 @@
 
 	  overlap =
 	    MIN (bin_high_pc, sym_high_pc) - MAX (bin_low_pc, sym_low_pc);
+	    
+      DBG (SAMPLEDEBUG,
+		   printf (
+	       "[assign_samples] bin_high_pc=%p, sym_high_pc=%p, bin_low_pc=%p, sym_low_pc=%p\n",
+	       bin_high_pc, sym_high_pc, bin_low_pc, sym_low_pc);
+	  );
+ 
+	    
 	  if (overlap > 0)
 	    {
 	      DBG (SAMPLEDEBUG,
@@ -326,6 +334,18 @@
 	      addr = symtab.base[j].addr;
 	      credit = overlap * time / hist_scale;
 
+      	DBG (SAMPLEDEBUG,
+      		{
+      		   Sym *excl = 	sym_lookup (&syms[EXCL_FLAT], addr);
+		   printf ("[assign_samples] credit %g, time %g, hist_scale %g\n",
+	       		credit, time, hist_scale);
+	       	   printf("[assign_samples] incl_flat = %p\n", sym_lookup (&syms[INCL_FLAT], addr));
+	       	   printf("[assign_samples] len = %ld\n", syms[INCL_FLAT].len);
+	       	   printf("[assign_samples] excl_flat = %p\n", excl);
+	       	   if (excl)
+	       	   	printf("[assign_samples] name = %s\n", excl->name);
+	       	}
+	    );
 	      /* Credit symbol if it appears in INCL_FLAT or that
 		 table is empty and it does not appear it in
 		 EXCL_FLAT.  */
diff -urNEBb binutils-2.14-orig/include/elf/ppc.h binutils-2.14/include/elf/ppc.h
--- binutils-2.14-orig/include/elf/ppc.h	2003-02-18 07:03:40.000000000 +0100
+++ binutils-2.14/include/elf/ppc.h	2003-12-02 14:09:40.000000000 +0100
@@ -120,6 +120,12 @@
   RELOC_NUMBER (R_PPC_EMB_BIT_FLD,	115)
   RELOC_NUMBER (R_PPC_EMB_RELSDA,	116)
 
+  /* Special MorphOS relocs. */
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL,	200)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_LO,	201)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_HI,	202)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_HA,	203)
+  
   /* These are GNU extensions to enable C++ vtable garbage collection.  */
   RELOC_NUMBER (R_PPC_GNU_VTINHERIT,	253)
   RELOC_NUMBER (R_PPC_GNU_VTENTRY,	254)
diff -urNEBb binutils-2.14-orig/ld/ChangeLog-9197 binutils-2.14/ld/ChangeLog-9197
--- binutils-2.14-orig/ld/ChangeLog-9197	2001-03-13 07:14:26.000000000 +0100
+++ binutils-2.14/ld/ChangeLog-9197	2003-12-02 14:09:40.000000000 +0100
@@ -147,6 +147,11 @@
 	since we need to be able to export different versions of the same
 	symbol.
 
+Thu Oct 16 13:21:14 1997  Fred Fish  <fnf@ninemoons.com>
+
+	* ldlang.c (new_afile): Only reference amiga_attribute when
+	the target is AmigaOS.
+
 Wed Oct 15 14:52:36 1997  Ian Lance Taylor  <ian@cygnus.com>
 
 	* scripttempl/pe.sc: Put .stab and .stabstr sections at end.
@@ -1283,6 +1288,12 @@
 	* ldcref.c (check_nocrossref): Skip symbols with no output
 	sections.
 
+Sun Aug  4 22:15:56 1996  Fred Fish  <fnf@ninemoons.com>
+
+	* ldfile.c (ldfile_open_file_search): Use alloca to allocate
+	dynamically sized array, rather than using a GNU C extension that
+	is not portable.	
+
 Fri Aug  2 14:57:49 1996  Ian Lance Taylor  <ian@cygnus.com>
 
 	* ldgram.y (LOADADDR): New terminal.
@@ -1509,6 +1520,10 @@
 	using shared libraries.
 	* configure: Rebuild with autoconf 2.10.
 
+Sat Jun 22 21:41:37 1996 Daniel Verite <daniel@brainstorm.eu.org>
+
+	* ldfile.c, lexsup.c: Sort the flavors.
+
 Fri Jun 21 17:40:56 1996  Joel Sherrill  <joel@merlin.gcs.redstone.army.mil>
 
 	* configure.tgt: Add support for *-*-rtems* configurations.
diff -urNEBb binutils-2.14-orig/ld/ChangeLog-9899 binutils-2.14/ld/ChangeLog-9899
--- binutils-2.14-orig/ld/ChangeLog-9899	2001-03-13 07:14:26.000000000 +0100
+++ binutils-2.14/ld/ChangeLog-9899	2003-12-02 14:09:40.000000000 +0100
@@ -1884,6 +1884,11 @@
 
 	* configure.tgt (sparclite*-*-elf): Added.
 
+Sun Mar  8 20:25:09 1998  Daniel Verite  <daniel@brainstorm.fr>
+
+	* ldlang.c (new_afile): Remove obsolete references to
+ 	amiga_attribute.
+
 Mon Mar  2 19:24:08 1998  Michael Meissner  <meissner@cygnus.com>
 
 	* ldlang.c (lang_size_sections): If the default memory region is
diff -urNEBb binutils-2.14-orig/ld/Makefile.am binutils-2.14/ld/Makefile.am
--- binutils-2.14-orig/ld/Makefile.am	2003-04-24 13:36:06.000000000 +0200
+++ binutils-2.14/ld/Makefile.am	2003-12-02 14:09:40.000000000 +0100
@@ -111,6 +111,9 @@
 	ea29k.o \
 	eaixppc.o \
 	eaixrs6.o \
+	eamiga.o \
+	eamiga_bss.o \
+	eamithlon.o \
 	ealpha.o \
 	earcelf.o \
 	earm_epoc_pe.o \
@@ -252,6 +255,8 @@
 	emipslit.o \
 	emipslnews.o \
 	emipspe.o \
+	emorphos.o \
+	emorphos_baserel.o \
 	emsp430x1101.o \
 	emsp430x1111.o \
 	emsp430x1121.o \
@@ -300,6 +305,8 @@
 	epdp11.o \
 	epjelf.o \
 	epjlelf.o \
+	eppcamiga.o \
+	eppcamiga_bss.o \
 	eppcmacos.o \
 	eppcnw.o \
 	eppcpe.o \
@@ -432,6 +439,21 @@
 GEN_DEPENDS = $(srcdir)/genscripts.sh stringify.sed
 @TDIRS@
 
+eamiga.c: $(srcdir)/emulparams/amiga.sh\
+   $(srcdir)/emultempl/amiga.em $(srcdir)/scripttempl/amiga.sc ${GEN_DEPENDS} 
+	${GENSCRIPTS} amiga "$(tdir_amiga)"
+eamiga_bss.c: $(srcdir)/emulparams/amiga_bss.sh\
+   $(srcdir)/emultempl/amiga.em $(srcdir)/scripttempl/amiga_bss.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} amiga_bss "$(tdir_amiga_bss)"
+eamithlon.c: $(srcdir)/emulparams/amithlon.sh \
+  $(srcdir)/emultempl/amithlon.em $(srcdir)/scripttempl/amithlon.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} amithlon "$(tdir_amithlon)"
+eppcamiga.c: $(srcdir)/emulparams/ppcamiga.sh\
+   $(srcdir)/emultempl/amiga.em $(srcdir)/scripttempl/amiga.sc ${GEN_DEPENDS} 
+	${GENSCRIPTS} ppcamiga "$(tdir_ppcamiga)"
+eppcamiga_bss.c: $(srcdir)/emulparams/ppcamiga_bss.sh\
+   $(srcdir)/emultempl/amiga.em $(srcdir)/scripttempl/amiga_bss.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} ppcamiga_bss "$(tdir_ppcamiga_bss)"
 ea29k.c: $(srcdir)/emulparams/a29k.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/a29k.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} a29k "$(tdir_a29k)"
@@ -1011,6 +1033,12 @@
 emipspe.c: $(srcdir)/emulparams/mipspe.sh \
   $(srcdir)/emultempl/pe.em $(srcdir)/scripttempl/pe.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} mipspe "$(tdir_mips)"
+emorphos.c: $(srcdir)/emulparams/morphos.sh \
+  $(srcdir)/emultempl/morphos.em $(srcdir)/scripttempl/morphos.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} morphos "$(tdir_morphos)"
+emorphos_baserel.c: $(srcdir)/emulparams/morphos_baserel.sh \
+  $(srcdir)/emultempl/morphos.em $(srcdir)/scripttempl/morphos_baserel.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} morphos_baserel "$(tdir_morphos)"
 emn10300.c: $(srcdir)/emulparams/mn10300.sh \
   $(srcdir)/emulparams/mn10200.sh \
   $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
@@ -1537,7 +1565,7 @@
 
 # We want install to imply install-info as per GNU standards, despite the
 # cygnus option.
-install: install-info
+#install: install-info
 
 # Stuff that should be included in a distribution.  The diststuff
 # target is run by the taz target in ../Makefile.in.
diff -urNEBb binutils-2.14-orig/ld/configure.host binutils-2.14/ld/configure.host
--- binutils-2.14-orig/ld/configure.host	2003-01-06 17:13:56.000000000 +0100
+++ binutils-2.14/ld/configure.host	2003-12-02 14:09:40.000000000 +0100
@@ -147,6 +147,9 @@
   HOSTING_CRT0=`echo "$HOSTING_CRT0" | sed -e "s,\\\`egrep.*\"\\\`,/lib/ld.so.1,"`
   ;;
 
+m68*-*-amigaos*)
+  HDEFINES=-mstackextend
+  ;;
 m68*-*-linux-gnu*)
   HOSTING_CRT0=`echo "$HOSTING_CRT0" | sed -e "s,\\\`egrep.*\"\\\`,/lib/ld.so.1,"`
   ;;
diff -urNEBb binutils-2.14-orig/ld/configure.tgt binutils-2.14/ld/configure.tgt
--- binutils-2.14-orig/ld/configure.tgt	2003-06-12 15:25:52.000000000 +0200
+++ binutils-2.14/ld/configure.tgt	2003-12-07 16:49:07.000000000 +0100
@@ -216,6 +216,7 @@
 			targ_extra_ofiles="deffilep.o pe-dll.o" ;;
 i[3456]86-*-interix*)	targ_emul=i386pe_posix;
  			targ_extra_ofiles="deffilep.o pe-dll.o" ;;
+i[3456]86be-*-amithlon*) targ_emul=amithlon;;
 i[3456]86-*-beospe*)    targ_emul=i386beos ;;
 i[3456]86-*-beos*)	targ_emul=elf_i386_be ;;
 i[3456]86-*-vxworks*)	targ_emul=i386aout ;;
@@ -340,6 +341,7 @@
 m68k-sony-*)		targ_emul=news ;;
 m68k-hp-bsd*)		targ_emul=hp300bsd ;;
 m68*-motorola-sysv*)	targ_emul=delta68 ;;
+m68*-*-amigaos*)	targ_emul=amiga ; targ_extra_emuls=amiga_bss;;
 m68*-*-aout)		targ_emul=m68kaout ;;
 m68*-*-coff)		targ_emul=m68kcoff ;;
 m68*-*-elf)		targ_emul=m68kelf ;;
@@ -456,6 +458,9 @@
 pdp11-*-*)		targ_emul=pdp11 ;;
 pjl*-*-*)	        targ_emul=pjlelf ; targ_extra_emuls="elf_i386" ;;
 pj*-*-*)	        targ_emul=pjelf ;;
+powerpc-*-amigaos*)	targ_emul=elf32ppc ;;
+powerpc-*-amigaoshunk*)	targ_emul=ppcamiga ; targ_extra_emuls=ppcamiga_bss;;
+powerpc-*-morphos*)	targ_emul=morphos ; targ_extra_emuls=morphos_baserel;;
 powerpc-*-freebsd*)	targ_emul=elf32ppc_fbsd;
 			targ_extra_emuls="elf32ppc elf32ppcsim";
 			targ_extra_libpath=elf32ppc;
@@ -595,6 +600,10 @@
 *-*-netbsd*)
   ;;
 
+powerpc-*-amigaos*)
+  NATIVE_LIB_DIRS='/gcc/local/lib /gcc/lib'
+  ;;
+
 alpha*-*-*)
   NATIVE_LIB_DIRS='/usr/local/lib /usr/ccs/lib /lib /usr/lib'
   ;;
diff -urNEBb binutils-2.14-orig/ld/emulparams/amiga.sh binutils-2.14/ld/emulparams/amiga.sh
--- binutils-2.14-orig/ld/emulparams/amiga.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/amiga.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x0
+PAGE_SIZE=0x0
+SEGMENT_SIZE=0x0
+NONPAGED_TEXT_START_ADDR=0x0
+TEMPLATE_NAME=amiga
+ARCH=m68k
diff -urNEBb binutils-2.14-orig/ld/emulparams/amiga_bss.sh binutils-2.14/ld/emulparams/amiga_bss.sh
--- binutils-2.14-orig/ld/emulparams/amiga_bss.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/amiga_bss.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga_bss
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x0
+PAGE_SIZE=0x0
+SEGMENT_SIZE=0x0
+NONPAGED_TEXT_START_ADDR=0x0
+TEMPLATE_NAME=amiga
+ARCH=m68k
diff -urNEBb binutils-2.14-orig/ld/emulparams/amithlon.sh binutils-2.14/ld/emulparams/amithlon.sh
--- binutils-2.14-orig/ld/emulparams/amithlon.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/amithlon.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,11 @@
+SCRIPT_NAME=amithlon
+OUTPUT_FORMAT="elf32-i386be-amithlon"
+#TEXT_START_ADDR=0x08048000
+#MAXPAGESIZE=0x1000
+MAXPAGESIZE=32
+#NONPAGED_TEXT_START_ADDR=0x08048000
+ARCH=i386
+MACHINE=
+NOP=0x9090
+TEMPLATE_NAME=amithlon
+GENERATE_SHLIB_SCRIPT=yes
diff -urNEBb binutils-2.14-orig/ld/emulparams/morphos.sh binutils-2.14/ld/emulparams/morphos.sh
--- binutils-2.14-orig/ld/emulparams/morphos.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/morphos.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,6 @@
+TEMPLATE_NAME=morphos
+SCRIPT_NAME=morphos
+OUTPUT_FORMAT="elf32-morphos"
+MAXPAGESIZE=0x40000
+ARCH=powerpc
+MACHINE=
diff -urNEBb binutils-2.14-orig/ld/emulparams/morphos_baserel.sh binutils-2.14/ld/emulparams/morphos_baserel.sh
--- binutils-2.14-orig/ld/emulparams/morphos_baserel.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/morphos_baserel.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,6 @@
+TEMPLATE_NAME=morphos
+SCRIPT_NAME=morphos_baserel
+OUTPUT_FORMAT="elf32-morphos"
+MAXPAGESIZE=0x40000
+ARCH=powerpc
+MACHINE=
diff -urNEBb binutils-2.14-orig/ld/emulparams/ppcamiga.sh binutils-2.14/ld/emulparams/ppcamiga.sh
--- binutils-2.14-orig/ld/emulparams/ppcamiga.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/ppcamiga.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x400
+PAGE_SIZE=0x400
+SEGMENT_SIZE=0x400
+NONPAGED_TEXT_START_ADDR=0x400
+TEMPLATE_NAME=amiga
+ARCH=powerpc
diff -urNEBb binutils-2.14-orig/ld/emulparams/ppcamiga_bss.sh binutils-2.14/ld/emulparams/ppcamiga_bss.sh
--- binutils-2.14-orig/ld/emulparams/ppcamiga_bss.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/emulparams/ppcamiga_bss.sh	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga_bss
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x400
+PAGE_SIZE=0x400
+SEGMENT_SIZE=0x400
+NONPAGED_TEXT_START_ADDR=0x400
+TEMPLATE_NAME=amiga
+ARCH=powerpc
diff -urNEBb binutils-2.14-orig/ld/ldctor.c binutils-2.14/ld/ldctor.c
--- binutils-2.14-orig/ld/ldctor.c	2002-11-30 09:39:44.000000000 +0100
+++ binutils-2.14/ld/ldctor.c	2003-12-02 14:09:40.000000000 +0100
@@ -266,10 +266,13 @@
       /* If the symbol is defined, we may have been invoked from
 	 collect, and the sets may already have been built, so we do
 	 not do anything.  */
-      if (p->h->type == bfd_link_hash_defined
-	  || p->h->type == bfd_link_hash_defweak)
+      /* dgv -- libnix v1.1 uses absolute sets that are also explicitly
+	 defined in the library so that the sets need to be build even
+	 if the symbol is defined */
+      if ((output_bfd->xvec->flavour != bfd_target_amiga_flavour) &&
+	  (p->h->type == bfd_link_hash_defined
+	  || p->h->type == bfd_link_hash_defweak))
 	continue;
-
       /* For each set we build:
 	   set:
 	     .long number_of_elements
@@ -362,14 +365,21 @@
 	      if (e->name != NULL)
 		minfo ("%T\n", e->name);
 	      else
+		if (e->section->owner)
 		minfo ("%G\n", e->section->owner, e->section, e->value);
+		else
+		  minfo ("%s\n", "** ABS **");
 	    }
 
 	  /* Need SEC_KEEP for --gc-sections.  */
 	  if (! bfd_is_abs_section (e->section))
 	    e->section->flags |= SEC_KEEP;
 
-	  if (link_info.relocateable)
+	  /* dgv -- on the amiga, we want the constructors to be relocateable
+	     objects. However, this should be arranged somewhere else (FIXME) */
+	  if (link_info.relocateable ||
+	      (output_bfd->xvec->flavour == bfd_target_amiga_flavour &&
+	       e->section != bfd_abs_section_ptr))
 	    lang_add_reloc (p->reloc, howto, e->section, e->name,
 			    exp_intop (e->value));
 	  else
diff -urNEBb binutils-2.14-orig/ld/ldfile.c binutils-2.14/ld/ldfile.c
--- binutils-2.14-orig/ld/ldfile.c	2003-04-18 16:33:48.000000000 +0200
+++ binutils-2.14/ld/ldfile.c	2003-12-02 14:09:40.000000000 +0100
@@ -37,6 +37,9 @@
 #include "libiberty.h"
 #include "filenames.h"
 
+static int n_flavors, flavors_len;
+char **flavors;
+
 const char * ldfile_input_filename;
 bfd_boolean  ldfile_assumed_script = FALSE;
 const char * ldfile_output_machine_name = "";
@@ -109,6 +112,32 @@
 /* Adds NAME to the library search path.
    Makes a copy of NAME using xmalloc().  */
 
+static int flavors_cmp (f1, f2)
+     const void *f1, *f2;
+{
+  return strcmp (*(char**)f1, *(char**)f2);
+}
+
+void
+sort_flavors ()
+{
+  if (n_flavors > 1)
+    qsort ((void*)flavors, n_flavors, sizeof(char**), flavors_cmp);
+}
+
+void
+ldfile_add_flavor (name)
+     char *name;
+{
+  n_flavors++;
+  if (flavors)
+    flavors = (char**) xrealloc ((PTR)flavors, n_flavors*sizeof (char*));
+  else
+    flavors = (char**) xmalloc (sizeof (char*));
+  flavors [n_flavors-1] = name;
+  flavors_len += strlen (name);
+}
+
 void
 ldfile_add_library_path (name, cmdline)
      const char *name;
@@ -305,6 +334,7 @@
      const char *suffix;
 {
   search_dirs_type *search;
+  char *flavor_dir = (char *) alloca (flavors_len + n_flavors + 1);
 
   /* If this is not an archive, try to open it in the current
      directory first.  */
@@ -337,6 +367,7 @@
        search = search->next)
     {
       char *string;
+      int i, count=n_flavors;
 
       if (entry->dynamic && ! link_info.relocateable)
 	{
@@ -361,15 +392,40 @@
       else
 	sprintf (string, "%s%s%s", search->name, slash, entry->filename);
 
+      for (count = n_flavors; count>=0; count--) {
+	*flavor_dir = '\0';
+	for (i=0; i<count; i++) {
+	  strcat (flavor_dir, flavors[i]);
+	  strcat (flavor_dir, slash);
+	}
+
+	string = (char *) xmalloc (strlen (search->name)
+				   + strlen (slash)
+				   + strlen (flavor_dir)
+				   + strlen (lib)
+				   + strlen (entry->filename)
+				   + strlen (arch)
+				   + strlen (suffix)
+				   + 1);
+	
+	if (entry->is_archive)
+	  sprintf (string, "%s%s%s%s%s%s%s", search->name, slash, flavor_dir,
+		   lib, entry->filename, arch, suffix);
+	else if (entry->filename[0] == '/' || entry->filename[0] == '.')
+	  strcpy (string, entry->filename);
+	else
+	  sprintf (string, "%s%s%s%s", search->name, slash, flavor_dir,
+		   entry->filename);
+	
       if (ldfile_try_open_bfd (string, entry))
 	{
 	  entry->filename = string;
-	  entry->sysrooted = search->sysrooted;
 	  return TRUE;
 	}
 
       free (string);
     }
+    }
 
   return FALSE;
 }
diff -urNEBb binutils-2.14-orig/ld/ldlang.h binutils-2.14/ld/ldlang.h
--- binutils-2.14-orig/ld/ldlang.h	2003-03-03 21:00:34.000000000 +0100
+++ binutils-2.14/ld/ldlang.h	2003-12-02 14:09:40.000000000 +0100
@@ -255,6 +255,8 @@
 #endif
   const char *target;
   bfd_boolean real;
+  /* Added for AMIGA support of section attributes */
+  int amiga_attribute;
 } lang_input_statement_type;
 
 typedef struct {
diff -urNEBb binutils-2.14-orig/ld/ldmain.c binutils-2.14/ld/ldmain.c
--- binutils-2.14-orig/ld/ldmain.c	2003-05-03 17:07:00.000000000 +0200
+++ binutils-2.14/ld/ldmain.c	2003-12-04 17:36:38.000000000 +0100
@@ -470,11 +470,15 @@
 
   /* Print error messages for any missing symbols, for any warning
      symbols, and possibly multiple definitions.  */
+#ifdef __amigaos4__
+  /* Make relocatable files executable as well */
+    output_bfd->flags |= EXEC_P;
+#else
   if (link_info.relocateable)
     output_bfd->flags &= ~EXEC_P;
   else
     output_bfd->flags |= EXEC_P;
-
+#endif
   ldwrite ();
 
   if (config.map_file != NULL)
diff -urNEBb binutils-2.14-orig/ld/scripttempl/amiga.sc binutils-2.14/ld/scripttempl/amiga.sc
--- binutils-2.14-orig/ld/scripttempl/amiga.sc	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/ld/scripttempl/amiga.sc	2003-12-02 14:09:40.000000000 +0100
@@ -0,0 +1,48 @@
+cat <<EOF
+OUTPUT_FORMAT("${OUTPUT_FORMAT}")
+OUTPUT_ARCH(${ARCH})
+
+${RELOCATING+${LIB_SEARCH_DIRS}}
+${STACKZERO+${RELOCATING+${STACKZERO}}}
+${SHLIB_PATH+${RELOCATING+${SHLIB_PATH}}}
+
+SECTIONS
+{
+  ${RELOCATING+. = ${TEXT_START_ADDR};}
+  .text :
+  {
+    ${RELOCATING+___machtype = ABSOLUTE(0x0);}
+    ${RELOCATING+__stext = .;}
+    *(.text)
+    ${RELOCATING+__etext = .;}
+    ${RELOCATING+___text_size = ABSOLUTE(__etext - __stext);}
+    ${PAD_TEXT+${RELOCATING+. = ${DATA_ALIGNMENT};}}
+  }
+  ${RELOCATING+. = ${DATA_ALIGNMENT};}
+  .data :
+  {
+    ${RELOCATING+__sdata = .;}
+    ${CONSTRUCTING+CONSTRUCTORS}
+    *(.data)
+    ${RELOCATING+__edata = .;}
+    ${RELOCATING+___data_size = ABSOLUTE(__edata - __sdata);}
+  }
+  ${RELOCATING+. = ALIGN(0x0);}
+  .bss :
+  {
+    ${RELOCATING+ __bss_start = .};
+    *(.bss)
+    *(COMMON)
+    ${RELOCATING+__end = . };
+    ${RELOCATING+___bss_size = ABSOLUTE(__end - __bss_start);}
+  }
+  .data_chip :
+  {
+    *(.data_chip)
+  }
+  .bss_chip :
+  {
+    *(.bss_chip)
+  }
+}
+EOF
